/**********************************************************************
 *
 *	getroot.c
 *
 **********************************************************************/

/*

Copyright 1986, 1987, 1988, 1989 by Hewlett-Packard Corporation
Copyright 1986, 1987, 1988, 1989 by the Massachusetts Institute of Technology

Permission to use, copy, modify, and distribute this
software and its documentation for any purpose and without
fee is hereby granted, provided that the above copyright
notice appear in all copies and that both that copyright
notice and this permission notice appear in supporting
documentation, and that the name of M.I.T. not be used in
advertising or publicity pertaining to distribution of the
software without specific, written prior permission.

Hewlett-Packard and M.I.T. make no representations about the 
suitability of this software for any purpose.  It is provided 
"as is" without express or implied warranty.

This software is not subject to any license of the American
Telephone and Telegraph Company or of the Regents of the
University of California.

*/

/**********************************************************************
 * include files
 **********************************************************************/

/*
 * ???
 */
#include <stdio.h>
/*
 * ???
 */
#include <X11/Xlib.h>
/*
 * ???
 */
#include <X11/Xutil.h>
/*
 * ???
 */
#include <X11/Xmd.h>
/*
 * ???
 */
#include <xtm.h>

/**********************************************************************
 * external variables
 **********************************************************************/

/*
 * points at the current display
 */
Display	*G_disp_ptr;

/**********************************************************************
 * function declarationss
 **********************************************************************/

int	get_current_screen();

/**********************************************************************
 * functions
 **********************************************************************/

/**********************************************************************
 *
 *	getroot
 *
 *	Match the root window of the screen containing the mouse.
 */
int
getroot(p, root_window_ptr)
/*
 * ???
 */
struct match_data	*p;
/*
 *    root window id is returned here.
 */
Window			*root_window_ptr;
{
	/*
	 * subwindow where mouse is
	 */
	Window	subw;

	/*
	 * figure out which screen contains the mouse
	 */
	p->screen_number = get_current_screen();
	/*
	 * use the root window of the current screen
	 */
	subw = RootWindow(G_disp_ptr, p->screen_number);
	/*
	 * get the width and height of the root window
	 */
	p->width = DisplayWidth(G_disp_ptr, p->screen_number);
	p->height = DisplayHeight(G_disp_ptr, p->screen_number);
	/* 
	 *    set return value, return success.
	 */
	*root_window_ptr = subw;
	return(1);
}
