/**********************************************************************
 *
 *	write_i_a.c
 *
 **********************************************************************/

/*

Copyright 1986, 1987, 1988, 1989 by Hewlett-Packard Corporation
Copyright 1986, 1987, 1988, 1989 by the Massachusetts Institute of Technology

Permission to use, copy, modify, and distribute this
software and its documentation for any purpose and without
fee is hereby granted, provided that the above copyright
notice appear in all copies and that both that copyright
notice and this permission notice appear in supporting
documentation, and that the name of M.I.T. not be used in
advertising or publicity pertaining to distribution of the
software without specific, written prior permission.

Hewlett-Packard and M.I.T. make no representations about the 
suitability of this software for any purpose.  It is provided 
"as is" without express or implied warranty.

This software is not subject to any license of the American
Telephone and Telegraph Company or of the Regents of the
University of California.

*/

/**********************************************************************
 * include files
 **********************************************************************/

/*
 * contains NULL constant
 */
#include <stdio.h>
/*
 * ???
 */
#include  <X11/Xmd.h>
/*
 * X windows library
 */
#include <X11/Xlib.h>
/*
 * client exerciser constants
 */
#include <xtm.h>

/**********************************************************************
 * external variables
 **********************************************************************/

/*
 * buffer for saved input actions
 */
extern unsigned char	G_ia_buffer[];
/*
 * current index into buf
 */
extern int		G_ia_count;

/**********************************************************************
 * function definitions
 **********************************************************************/

void	wrchk();
void	wrchk2();

/**********************************************************************
 * functions
 **********************************************************************/

/*****************************************************************************
 *
 *	write_input_actions
 *
 *	This function writes accumulated input actions to the test script file.
 */
void
write_input_actions(ofd)
/*
 * ???
 */
int	ofd;
{
	char	buf[WRITE_BUFFER_SIZE];

	(void) sprintf(buf, "k%d ", G_ia_count);
	/*
	 * indicate that input actions follow
	 */
	wrchk(ofd, buf);
	/*
	 * write the input actions to the test script file
	 */
	wrchk2(ofd,
	       (char *) G_ia_buffer,
	       (unsigned int) G_ia_count,
	       "Error writing input actions to test script");
	/*
	 * initialize input action count
	 */
	G_ia_count = 0;
}
